//+------------------------------------------------------------------+
//|                                                     Ma Slope.mq4 |
//|                        Copyright 2019, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2019, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict
#property indicator_separate_window

#property indicator_buffers 2
#property indicator_color1 clrWhite
#property indicator_width1 1


extern string Moving_Average_Settings;
extern int SMA_Period = 50;
extern double Ma_Criteria = 1.02;

double Main[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
   IndicatorBuffers(1);
   IndicatorDigits(Digits + 3);
   
   SetIndexBuffer(0,Main);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexLabel(0,"MA Slope");
   
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---

   int counted_bars, limit;
   
   counted_bars = IndicatorCounted();
   if(!counted_bars) limit = Bars - 1 - 3;   // -1-3 is applicable when i+3 is maximum look back used in indicator code below. -1-1 is applicable when i+1 is maximum look back used in indicator code below
   else limit = Bars - counted_bars -1;
   
// if(!prev_calculated) limit = rates_total ;
//  else limit = rates_total - prev_calculated;
   // printf("limit is ",limit);
  
     for( int i = 1; i <= limit; i++)
      {
        double Ma_0 = iMA(NULL,0,SMA_Period,0,MODE_SMA,PRICE_CLOSE,i) * 100000;
        double Ma_1 = iMA(NULL,0,SMA_Period,0,MODE_SMA,PRICE_CLOSE,i + 1) * 100000;
        
        
         Main[i] = ((Ma_0 - Ma_1))/Close[i + 1];
      }
   
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
